function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Defines the props allowed to be used with any chart that inherits
 * from a BaseMixin.
 */
var events = ['onRenderlet', 'onPreTransition', 'onPreRender', 'onPostRender', 'onPreRedraw', 'onPostRedraw', 'onFiltered', 'onZoomed'];
/**
 * Transforms the previous props to dc.js compatible chart methods
 * This can become useful to combine multiple props into a single function
 * Or to provide proper naming, eg. setMyProp(5) to myProp=5
 * @param chart
 * @param props
 */

export function baseMixin(chart, props) {
  var filterHandler = props.filterHandler,
      showControls = props.showControls,
      rest = _objectWithoutProperties(props, ["filterHandler", "showControls"]); // chart[showControls ? 'turnOffControls' : 'turnOnControls']()


  filterHandler && chart.addFilterHandler(filterHandler);
  events.forEach(function (event) {
    return event in rest && chart.on(event, rest[event]);
  });
  return rest;
}