export function combineMixins() {
  var mixins = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return function (chart, props) {
    // Transforms the received props into corresponding chart methods
    // Ensures that we can map only a subset of props to mixin methods
    var unhandledProps = mixins.reduce(function (value, mixin) {
      return mixin(chart, value);
    }, props); // Invoke the remaining generic props to corresponding methods

    Object.keys(unhandledProps).forEach(function (prop) {
      return prop in chart && chart[prop](unhandledProps[prop]);
    });
  };
}